//skill1: TriggerDist 200
//skill2: TriggerHeight 200
//skill3: MoveHeight 250
//skill4: MoveSpeed 10
action DoorSlideUp()
{
	var startheight;
	var distance;
	
	//Update the collision hull
	c_setminmax(my);
	
	//The "sensor" position
	VECTOR center;
	
	/*Calculated from the bounding boxes min and max values
	as the half of their sum is the offset from the origin
	to the objects center.
	This offset is rotated with the object and the objects
	position is added. The height is user defined, relative
	to the objects lowest point.*/
	center.x = (my->min_x+my->max_x)*0.5;
	center.y = (my->min_y+my->max_y)*0.5;
	center.z = my->min_z+my->skill2;
	vec_rotate(&center, &my->pan);
	vec_add(&center, &my->x);
	
	//Store the starting height
	startheight = my.z;
	
	while(1)
	{
		//Get the distance between camera and door
		distance = vec_dist(&camera->x, &center);
		
		//Open the door if the camera is close
		if(distance < my->skill1)
		{
			if(my->z < my->skill3+startheight)
			{
				my->z += my->skill4*time_step;
			}else
			{
				my->z = startheight+my->skill3;
			}
		}else//close it otherwize
		{
			if(my->z > startheight)
			{
				my->z -= my->skill4*time_step;
			}else
			{
				my->z = startheight;
			}
		}
		
		wait(1);
	}
}

//skill1: TriggerDist 200
//skill2: TriggerHeight 200
//skill3: MoveRange 200
//skill4: VelocityX 0
//skill5: VelocityY 10
//skill6: VelocityZ 0
action DoorSlide()
{
	var startheight;
	var distance;
	
	//Update the collision hull
	c_setminmax(my);
	
	//The "sensor" position
	VECTOR center;
	center.x = (my->min_x+my->max_x)*0.5;
	center.y = (my->min_y+my->max_y)*0.5;
	center.z = my->min_z+my->skill2;
	vec_rotate(&center, &my->pan);
	vec_add(&center, &my->x);
	
	//Store the starting position
	VECTOR startpos;
	vec_set(&startpos, &my->x);
	
	//Rotate the velocity vector
	vec_rotate(&my->skill4, &my->pan);
	
	VECTOR scaledvel;
	
	while(1)
	{
		//Get the distance between camera and door
		distance = vec_dist(&camera->x, &center);
		
		//Open the door if the camera is close
		if(distance < my->skill1)
		{
			if(vec_dist(&startpos, &my->x) < my->skill3)
			{
				vec_set(&scaledvel, &my->skill4);
				vec_scale(&scaledvel, time_step);
				
				vec_add(&my->x, &scaledvel);
			}else
			{
				vec_set(&scaledvel, &my->skill4);
				vec_normalize(&scaledvel, my->skill3);
				vec_add(&scaledvel, &startpos);
				vec_set(&my->x, &scaledvel);
			}
		}else//close it otherwize
		{
			if(vec_dist(&startpos, &my->x) > vec_length(&my->skill4)*time_step)
			{
				vec_set(&scaledvel, &my->skill4);
				vec_scale(&scaledvel, time_step);
				
				vec_sub(&my->x, &scaledvel);
			}else
			{
				vec_set(&my->x, &startpos);
			}
		}
		
		wait(1);
	}
}

//skill1: TriggerDist 200
//skill2: TriggerHeight 200
//skill3: MoveRange 120
//skill4: VelocityPan 10
//skill5: VelocityTilt 0
//skill6: VelocityRoll 0
action DoorRotate()
{
	var startheight;
	var distance;
	
	//Update the collision hull
	c_setminmax(my);
	
	//The "sensor" position
	VECTOR center;
	center.x = (my->min_x+my->max_x)*0.5;
	center.y = (my->min_y+my->max_y)*0.5;
	center.z = my->min_z+my->skill2;
	vec_rotate(&center, &my->pan);
	vec_add(&center, &my->x);
	
	//Store the starting position
	VECTOR startrot;
	vec_set(&startrot, &my->pan);
	
	//Rotate the velocity vector
	vec_rotate(&my->skill4, &my->pan);
	
	VECTOR scaledvel;
	
	while(1)
	{
		//Get the distance between camera and door
		distance = vec_dist(&camera->x, &center);
		
		//Open the door if the camera is close
		if(distance < my->skill1)
		{
			if(vec_dist(&startrot, &my->pan) < my->skill3)
			{
				vec_set(&scaledvel, &my->skill4);
				vec_scale(&scaledvel, time_step);
				
				vec_add(&my->pan, &scaledvel);
			}else
			{
				vec_set(&scaledvel, &my->skill4);
				vec_normalize(&scaledvel, my->skill3);
				vec_add(&scaledvel, &startrot);
				vec_set(&my->pan, &scaledvel);
			}
		}else//close it otherwize
		{
			if(vec_dist(&startrot, &my->pan) > vec_length(&my->skill4)*time_step)
			{
				vec_set(&scaledvel, &my->skill4);
				vec_scale(&scaledvel, time_step);
				
				vec_sub(&my->pan, &scaledvel);
			}else
			{
				vec_set(&my->pan, &startrot);
			}
		}
		
		wait(1);
	}
}
